/*
##########################################
#      8X8X8 RGB LED CUBE BY PIERROT     #
#            PROGRAMME REV 0.1           #
#              LE 17/05/2015             #
#          Mail : lbc-fr@live.fr         #
##########################################

/!\ 512 Leds RGB à ANODE commune

/!\ Version IDE Arduino utilisée : 1.0.1

/!\ - Placer la bibliothèque "tlc5940" dans "Documents/Arduino/libaries"
    - Ouvrir le dossier contenant la bibliothèque, puis ouvrir "tlc_config.h" avec un éditeur de texte
    - Modifier la ligne "#define NUM_TLCS    1" avec "#define NUM_TLCS    12"


CABLAGE PCB :

TLC5940 / ARDUINO
 ---------------
|  OUT  | ----  |  P
|---------------|                     ---------
| GSCLK |  03   |  1      OUT15  15 -|         |- 14  OUT14
|---------------|         XERR   16 -|         |- 13  OUT13
|  +5V  |  +5V  |  0      SOUT   17 -|    T    |- 12  OUT12
|---------------|         GSCLK  18 -|    L    |- 11  OUT11
|  GND  |  GND  |         DCPRG  19 -|    C    |- 10  OUT10
|-------|-------|         IREF   20 -|         |- 09  OUT9
|-------|-------|         VCC    21 -|    5    |- 08  OUT8
| BLANK |  10   |  P      GND    22 -|    9    |- 07  OUT7
|---------------|         BLANK  23 -|    4    |- 06  OUT6
| XLAT  |  09   |  9      XLAT   24 -|    0    |- 05  OUT5
|---------------|         SCLK   25 -|         |- 04  OUT4
| SCLK  |  13   |         SIN    26 -|         |- 03  OUT3
|---------------|         VPRG   27 -|         |- 02  OUT2
| ----  | 11(IN)|         OUT0   28 -|       o |- 01  OUT1
 ---------------                      ---------

- Le "IN" du premier PCB est relié à la broche 11 de l'arduino
- Le "OUT" du premier PCB au second PCB sur le "IN" etc...
- Tous les autres fils sont reliés entre eux sur chaque PCB (GSCLK/+5V/GND/BLANK/XLAT/SCLK)
- (Optionnel) Il faut placer un condensateur de découplage (Céramique 0.1uF (104)) sur chaque TLC5940 entre le +5v et le GND

*/


#include <Tlc5940.h>             // On appele les bibliothèques pour le fonctionnement du TLC5940
#include <tlc_animations.h>
#include <tlc_config.h>
#include <tlc_fades.h>
#include <tlc_progmem_utils.h>
#include <tlc_servos.h>
#include <tlc_shifts.h>
#include <DHT.h>

#define DHTPIN 48  // Capteur humidite/temperature
#define DHTTYPE DHT21   // DHT 21 (AM2301)
DHT dht(DHTPIN, DHTTYPE);
#define etage1 40  // Pins pour utilisation transistor
#define etage2 41  // Alimentation en +5v pour chaque étage
#define etage3 42
#define etage4 43
#define etage5 44
#define etage6 45
#define etage7 46
#define etage8 47
#define capteur A2
#define sensorPin A5


int etages[] = {etage1, etage2, etage3, etage4, etage5, etage6, etage7, etage8}; // Tableau des etages
int TableauSerpent[] = {1, -1, 8, -8};
int TourVert[] = {136,128,129,134,135,143,183,191,190,185,184,176};
int TourBleu[] = {72,64,65,70,71,79,119,127,126,121,120,112};
int TourRouge[] = {8,0,1,6,7,15,55,63,62,57,56,48};
int Arti[] = {18,19,20,21,26,27,28,29,34,35,36,37,42,43,44,45};
int temps1=1;
int val = 1000;
int val2 = 1500;
int val3 = 700;
int val4 = 700;
int d5 = 8;
int sensorValue = 0;
int prevValue;


void setup()    // Configuration
{
  pinMode(etage1, OUTPUT);  // Toutes les pins de contrôle transistor en sortie
  pinMode(etage2, OUTPUT);
  pinMode(etage3, OUTPUT);
  pinMode(etage4, OUTPUT);
  pinMode(etage5, OUTPUT);
  pinMode(etage6, OUTPUT);
  pinMode(etage7, OUTPUT);
  pinMode(etage8, OUTPUT);
  
  Serial.begin(9600);  // Debug
  Tlc.init();    // On initialise la bibliothèque TLC5940
}

void loop()    // Boucle principale
{
  
  Fire();
 
}
